#!/usr/bin/env python
# -*- coding: utf_8 -*-

#
#   PROYECTO TUQUITO OLPC
#   DESARROLLADORES: Claudio Ceballos Paz, Gonzalo Delgado
#    Este software es libre y se distribuye bajo las
#   condiciones de la General Public License
#

import pygtk
pygtk.require('2.0')

import os
import time
import decimal
from decimal import Decimal, Context

import gtk
import gtk.glade
import pango

try:
    import sugar.env
    from sugar.activity import activity
    SINSUGAR = False
except:
    print 'Calculadora light: sin sugar :-P'
    SINSUGAR = True

from utiles import Debugmsg


class Calculadora(gtk.VBox):

    def __init__(self, debug=Debugmsg(False)):
        gtk.VBox.__init__(self, False, 0)

        self.debug = debug
        self.emucalc = emucalc(debug=self.debug)
       
        if SINSUGAR:
            self.debug.mensaje('Ejecutandose sin Sugar')
            appdir = os.getcwd()
        else:
            self.debug.mensaje('¡¡Estamos dentro de Sugar!!')
            appdir = os.path.join(activity.get_bundle_path(), 'calculadora')

        self.debug.mensaje('Directorio de la aplicación: %s'%str(appdir))

        if SINSUGAR:
            xml = gtk.glade.XML(os.path.join(os.path.join(appdir,'glade'),\
                                'calculadora.glade'))
            self.ventana = xml.get_widget('ventana')
        else:
            xml = gtk.glade.XML(os.path.join(os.path.join(appdir,'glade'),\
                                'calculadora.glade'), "cajacalcu")
        self.debug.mensaje('Cargado el xml de glade')

        self.caja = xml.get_widget('cajacalcu')

        self.display = xml.get_widget('display')

        self.bnumeros = list()
        self.debug.mensaje('Hasta acá todo bien')

        for i in range(0,10):
            self.bnumeros.append(xml.get_widget('bnro%d'%i))
            self.debug.mensaje('Cargando boton %d'%i)
       
        self.boperaciones = { '+':xml.get_widget('bop+'),
                              '-':xml.get_widget('bop-'),
                              '*':xml.get_widget('bop*'),
                              '/':xml.get_widget('bop/') }

        #  Cuando se presione cualquier boton de operacion (+,-,*,/)
        # se llama a la funcion on_bop_pressed
        for k in self.boperaciones.keys():
            self.boperaciones[k].connect('pressed', self.on_bop_pressed, k)
            self.debug.mensaje('conectando el evento "pressed" al boton %s'%k)

        self.bcontroles = { 'ce':xml.get_widget('bce'),
                       'ac':xml.get_widget('bac') }
        self.debug.mensaje('Cargados los botones "ce" y "ac"')

        self.display = xml.get_widget('display')
        self.debug.mensaje('Cargado el display')
        # Justificamos a la derecha
        self.display.set_alignment(1.0)
        # Ponemos una fuente mas grande en la caja de texto
        self.display.modify_font(pango.FontDescription('Helvetica Bold 36'))
        self.display.set_text('0')
       

        #  Cuando se presione cualquier boton numerico, se llama
        # a la funcion on_bnro_pressed, que muestra dicho numero
        # en el display
        for i in range(0,10):
            self.bnumeros[i].connect('pressed', self.on_bnro_pressed, i)
            self.debug.mensaje('Conectado el evento "pressed" al boton %d'%i)

        xml.signal_autoconnect(self)    # Conectamos las señales definidas en Glade
        self.debug.mensaje('Conectados los eventos restantes con autoconnect')
        if SINSUGAR:
            self.ventana.show_all()

    def _mostrar(self):
        p = self.emucalc.pantalla()
        if p != '0':
            self.debug.mensaje('Eliminando ceros sobrantes')
            if self.emucalc.coma_used():
                p = p.strip('0')
        if p[0] == '.':
            self.debug.mensaje('Número decimal, reponiendo cero adelante')
            p = "0%s"%p
        self.display.set_text(p)


    def do_quit(self):
        self.debug.mensaje('Saliendo de la aplicación')

    def on_ventana_destroy(self, ventana):
        self.debug.mensaje('Cerraron la ventana, terminamos el loop GTK')
        gtk.main_quit()


    # Pensar ponerle un threshold para que
    # repita el número al manter apretado el botón
    def on_bnro_pressed(self, boton, nro):
        self.debug.mensaje("Botón %d presionado"%nro)
        self.emucalc.agregardig(nro)
        self.display.set_text(self.emucalc.pantalla())

    def on_bcoma_pressed(self, widget):
        self.debug.mensaje('Botón , presionado')
        self.emucalc.agregarcoma()

    def on_bop_pressed(self, boton, op):
        self.debug.mensaje('Botón %s presionado'%op)
        self.emucalc.agregarop(op)
        # self.display.set_text(self.emucalc.pantalla().strip('0'))
        self._mostrar()

    def on_bigual_pressed(self, widget):
        self.debug.mensaje('Botón = presionado')
        self.emucalc.calcular()
        # self.display.set_text(self.emucalc.pantalla().strip('0'))
        self._mostrar()

    def on_bmenos_pressed(self, widget):
        self.debug.mensaje('Botón (-) presionado')
        self.emucalc.cambiarsigno()
        # self.display.set_text(self.emucalc.pantalla().strip('0'))
        self._mostrar()

    def on_bce_clicked(self, widget):
        self.debug.mensaje('Botón CE presionado')
        self.emucalc.ce()
        self._mostrar()

    def on_bac_clicked(self, widget):
        self.debug.mensaje('Botón AC presionado')
        self.emucalc.ac()
        # self.display.set_text(self.emucalc.pantalla().strip('0'))
        self._mostrar()

    # Detectamos la tecla presionada y mandamos la accion correspondiente
    def on_cajacalcu_key_press_event(self, widget, event):
        self.debug.mensaje("Tecla presionada: %d"%event.keyval)
        if event.keyval >= 48 and event.keyval <= 57:
            self.emucalc.agregardig(event.keyval - 48)
        elif event.keyval == 43:
            self.emucalc.agregarop('+')
        elif event.keyval == 45:
            self.emucalc.agregarop('-')
        elif event.keyval == 42:
            self.emucalc.agregarop('*')
        elif event.keyval == 47:
            self.emucalc.agregarop('/')
        elif event.keyval == 65293:
            self.emucalc.calcular()
        elif event.keyval == 44:
            self.emucalc.agregarcoma()
        # self.display.set_text(self.emucalc.pantalla())
        self._mostrar()

    def main(self):
        self.debug.mensaje('Iniciando loop GTK')
        gtk.main()

class emucalc:
    """

    Emulador simple de calculadora de bolsillo
    La función agregardig se corresponde con el presionar de
    cualquiera de los botones numéricos, y así las demás
    funciones agregar...
    La función calcular equivale a presionar el botón =
    En cualquier momento se puede ver el contenido de la pantalla
    con la función pantalla.

    """
   
    def __init__(self, prec=20, debug=Debugmsg(msg=False)):
        self.__contexto = Context(prec, decimal.ROUND_HALF_UP)
        self.__contexto.traps[decimal.DivisionByZero] = False
        self.__contexto.traps[decimal.InvalidOperation] = False
        self.__numpantalla = self.__contexto.create_decimal('0')
        self.__nummemoria= self.__contexto.create_decimal('0')
        self.__op = None
        self.__nuevonum = True
        self.__coma = False
        #  Normalmente al agregar un dígito multiplicamos por 10 el número
        # en pantalla y sumamos el dígito agregado. Si el número fuera decimal
        # esto cambia, y ahi entra la variable "corredor".
        self.__corredor = self.__contexto.create_decimal('10')
        self.__oppte = False
        self.__debug = debug
        self.__norm = False

    def coma_used(self):
        return self.__coma

    def agregardig(self, num):
        """ Emula el presionar de un botón numérico """
        self.__debug.mensaje('Agregando digito %d'%num)

        # Si hay una operación en curso (el último botón presionado fue el de una operación)
        if self.__op is not None:
            self.__oppte = True
            self.__debug.mensaje('Operación en curso, activamos el flag oppte')
        if self.__nuevonum:
            self.__debug.mensaje('Número nuevo')
            if not self.__coma:
                self.__debug.mensaje('Sin coma')
                self.__numpantalla = self.__contexto.create_decimal(num)
            else:
                #  Si presionamos la coma antes de este número, el número a
                # representar es decimal y tenemos que hacer los ajustes necesarios
                self.__debug.mensaje('Con coma')
                self.__numpantalla = self.__corredor*Decimal(num)
                self.__corredor = self.__corredor*self.__contexto.create_decimal('0.1')
            self.__nuevonum = False
        else:
            self.__debug.mensaje('Numero existente')
            if not self.__coma:
                self.__debug.mensaje('Sin coma')
                self.__numpantalla = self.__corredor*self.__numpantalla + self.__contexto.create_decimal(num)
           
            else:
                self.__debug.mensaje('Con coma')
                #  El dígito ingresado tiene que ir siempre después del último
                # dígito en pantalla. Si hay una coma multiplicamos el dígito
                # ingresado por 10^(-n), siendo 'n' la cantidad de números despues
                # de la coma (+ 1) y lo sumamos al número en pantalla
                self.__numpantalla  = self.__numpantalla + self.__corredor*self.__contexto.create_decimal(num)
                self.__corredor = self.__corredor*self.__contexto.create_decimal('0.1')
        return self.__numpantalla

    def agregarcoma(self):
        if not self.__coma:
            self.__debug.mensaje('Agregando coma')
            self.__coma = True
            #  Cambiamos el valor del corredor a 0,1 para que el próximo dígito
            # ingresado se ponga después de la coma
            self.__corredor = self.__contexto.create_decimal('0.1')
        else:
            self.__debug.mensaje('No se agrega la coma, ya hay una agregada')

    def agregarop(self, op):
        self.__debug.mensaje('Agregando operacion')
        if self.__oppte:
            #  Si hay una operación pendiente, la calculamos y ponemos
            # su resultado en la memoria
            self.__debug.mensaje('Operacion pendiente, calculando..')
            self.calcular()
            self.__oppte = False
        self.__nummemoria = self.__numpantalla
        self.__debug.mensaje('Memoria tomando el valor en pantalla')
        self.reset()
        self.__debug.mensaje('Valores reseteados')
        self.__op = op
        return self.__numpantalla
               
    def cambiarsigno(self):
        self.__debug.mensaje('Cambiando signo del número en pantalla')
        if str(self.__numpantalla) != '0':
            self.__numpantalla = self.__contexto.multiply(self.__contexto.create_decimal('-1'), self.__numpantalla)

    def calcular(self):
        if not self.__oppte:
            self.reset()
            return self.__numpantalla
        self.__debug.mensaje('Calculando... operacion: %s %s %s'%(str(self.__nummemoria), self.__op, str(self.__numpantalla)))
        if self.__op == '+':
            r = self.__contexto.add(self.__nummemoria, self.__numpantalla)
        elif self.__op == '-':
            r = self.__contexto.subtract(self.__nummemoria, self.__numpantalla)
        elif self.__op == '*':
            r = self.__contexto.multiply(self.__nummemoria, self.__numpantalla)
        # ¡¡ARREGLAME!! faltan controles de division por cero
        elif self.__op == '/':
            r = self.__contexto.divide(self.__nummemoria, self.__numpantalla)
        else:
            self.__debug.mensaje('Sin operacion: resultado = %s'%str(self.__numpantalla))
            return self.__numpantalla
        self.__numpantalla = r
        self.__debug.mensaje('El numero actual es el resultado de la operacion')
        self.__nummemoria = self.__contexto.create_decimal('0')
        self.__debug.mensaje('Ponemos el valor de la memoria en cero')
        self.reset()
        self.__oppte = False
        self.__op = None
        self.__debug.mensaje('Valores reseteados')
        return r

    def reset(self):
        self.__nuevonum = True
        self.__coma = False
        self.__corredor = self.__contexto.create_decimal('10')

    def ce(self):
        self.reset()
        self.__numpantalla = self.__contexto.create_decimal('0')

    def ac(self):
        self.ce()
        self.__numpantalla = self.__contexto.create_decimal('0')
        self.__oppte = False
        self.__op = None

    def pantalla(self):
        self.__debug.mensaje('Actualizando pantalla')
        print self.__numpantalla
        if  (str(self.__numpantalla) == 'NaN') or \
            (str(self.__numpantalla) == 'Infinity') or \
            (str(self.__numpantalla) == '-Infinity'):
            self.__debug.mensaje('Operación incorrecta o infinito: %s'%self.__numpantalla)
            self.reset()
            self.__oppte = False
            self.__op = None
            self.__debug.mensaje('Valores reseteados')

            return('ERROR: %s'%self.__numpantalla)
        cero = decimal.BasicContext.create_decimal(0)
        diez = decimal.BasicContext.create_decimal(10)
        r = decimal.BasicContext.create_decimal(str(self.__numpantalla))
        # ¡¡ARREGLAME!! *tiene* que haber una forma mas simple de hacer esto:
        if decimal.BasicContext.divmod(r, diez)[1] != 0:
            if decimal.BasicContext.subtract(r.to_integral(), r) == cero:
                r = r.normalize()
        return str(r)

    def memoria(self):
        return str(self.__nummemoria)


if __name__ == '__main__':
   
    calculeta = Calculadora(debug=Debugmsg(msg=True, prefijo='Calcu'))
    calculeta.main()
